Index: pkpgcounter/trunk/tests/runtest.sh
===================================================================
--- pkpgcounter/trunk/tests/runtest.sh (revision 220)
+++ pkpgcounter/trunk/tests/runtest.sh (revision 235)
@@ -11,8 +11,8 @@
 
 echo -n "File master.ps should be 16 pages long, result is : "
-python ../pdlanalyzer/analyzer.py master2.ps
+python ../pkpgpdls/analyzer.py master2.ps
 
 echo "Analyzing testsuite..."
 for file in testsuite.* ; do
-    echo -n "$file ===> " && python ../pdlanalyzer/analyzer.py "$file" ;
+    echo -n "$file ===> " && python ../pkpgpdls/analyzer.py "$file" ;
 done    
Index: pkpgcounter/trunk/pkpgpdls/tiff.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/tiff.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/tiff.py (revision 235)
@@ -27,5 +27,5 @@
 from struct import unpack
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/pdf.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdf.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/pdf.py (revision 235)
@@ -25,5 +25,5 @@
 import re
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 235)
@@ -26,5 +26,5 @@
 import mmap
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/postscript.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/postscript.py (revision 235)
@@ -25,5 +25,5 @@
 import popen2
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/escp2.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escp2.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/escp2.py (revision 235)
@@ -24,5 +24,5 @@
 import sys
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/ooo.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/ooo.py (revision 232)
+++ pkpgcounter/trunk/pkpgpdls/ooo.py (revision 235)
@@ -26,5 +26,5 @@
 import zipfile
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/dvi.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/dvi.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/dvi.py (revision 235)
@@ -27,5 +27,5 @@
 from struct import unpack
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/pclxl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 220)
+++ pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 235)
@@ -27,5 +27,5 @@
 from struct import unpack
 
-from pdlanalyzer import pdlparser
+import pdlparser
 
 class Parser(pdlparser.PDLParser) :
Index: pkpgcounter/trunk/pkpgpdls/analyzer.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 229)
+++ pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 235)
@@ -23,7 +23,6 @@
 import tempfile
 
-from pdlanalyzer import version, pdlparser, \
-                        postscript, pdf, pcl345, pclxl, \
-                        escp2, dvi, tiff, ooo
+import version, pdlparser, postscript, pdf, pcl345, pclxl, \
+       escp2, dvi, tiff, ooo
 
 class PDLAnalyzer :    
Index: pkpgcounter/trunk/pkpgpdls/version.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/version.py (revision 229)
+++ pkpgcounter/trunk/pkpgpdls/version.py (revision 235)
@@ -20,5 +20,5 @@
 #
 
-__version__ = "1.55"
+__version__ = "1.56"
 
 __doc__ = """pkpgcounter : a generic Page Description Languages parser."""
Index: pkpgcounter/trunk/setup.py
===================================================================
--- pkpgcounter/trunk/setup.py (revision 211)
+++ pkpgcounter/trunk/setup.py (revision 235)
@@ -34,6 +34,6 @@
     sys.exit(-1)
 
-sys.path.insert(0, "pdlanalyzer")
-from pdlanalyzer.version import __version__, __doc__
+sys.path.insert(0, "pkpgpdls")
+from pkpgpdls.version import __version__, __doc__
 
 data_files = []
@@ -58,5 +58,5 @@
       author_email = "alet@librelogiciel.com",
       url = "http://www.librelogiciel.com/software/",
-      packages = [ "pdlanalyzer" ],
+      packages = [ "pkpgpdls" ],
       scripts = [ "bin/pkpgcounter" ],
       data_files = data_files)
Index: pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- pkpgcounter/trunk/bin/pkpgcounter (revision 229)
+++ pkpgcounter/trunk/bin/pkpgcounter (revision 235)
@@ -24,7 +24,7 @@
 
 import sys
-from pdlanalyzer.version import __version__, __author__, __authoremail__, \
+from pkpgpdls.version import __version__, __author__, __authoremail__, \
                                 __years__, __gplblurb__
-from pdlanalyzer import analyzer
+from pkpgpdls import analyzer
 
 __doc__ = """pkpgcounter v%(__version__)s (c) %(__years__)s %(__author__)s
Index: pkpgcounter/trunk/clean.sh
===================================================================
--- pkpgcounter/trunk/clean.sh (revision 211)
+++ pkpgcounter/trunk/clean.sh (revision 235)
@@ -22,4 +22,6 @@
 # Use this to clean the tree from temporary files
 
+rm -f MANIFEST
+rm -fr build dist
 find . -name "*.bak" -exec rm -f {} \;
 find . -name "*~" -exec rm -f {} \;
Index: pkpgcounter/trunk/NEWS
===================================================================
--- pkpgcounter/trunk/NEWS (revision 229)
+++ pkpgcounter/trunk/NEWS (revision 235)
@@ -22,4 +22,9 @@
 pkpgcounter News :
    
+  * 1.56 :
+  
+    - Renamed the library from pdlanalyzer into pkpgpdls to avoid problems
+      when the code will be integrated back into PyKota.
+      
   * 1.55 : 
   
Index: pkpgcounter/trunk/README
===================================================================
--- pkpgcounter/trunk/README (revision 229)
+++ pkpgcounter/trunk/README (revision 235)
@@ -73,5 +73,5 @@
         
       This will usually install the pkpgcounter into /usr/bin and  
-      the library into /usr/lib/python2.?/site-packages/pdlanalyzer/
+      the library into /usr/lib/python2.?/site-packages/pkpgpdls/
         
   2 - Use pkpgcounter :