Index: pkpgcounter/trunk/BUGS
===================================================================
--- pkpgcounter/trunk/BUGS (revision 276)
+++ pkpgcounter/trunk/BUGS (revision 303)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/tests/README
===================================================================
--- pkpgcounter/trunk/tests/README (revision 211)
+++ pkpgcounter/trunk/tests/README (revision 303)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/tiff.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/tiff.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/tiff.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pdf.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdf.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/pdf.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 294)
+++ pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/postscript.py (revision 292)
+++ pkpgcounter/trunk/pkpgpdls/postscript.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/escp2.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/escp2.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/escp2.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/ooo.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/ooo.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/ooo.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pdlparser.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 271)
+++ pkpgcounter/trunk/pkpgpdls/pdlparser.py (revision 303)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/inkcoverage.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 287)
+++ pkpgcounter/trunk/pkpgpdls/inkcoverage.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/__init__.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/__init__.py (revision 211)
+++ pkpgcounter/trunk/pkpgpdls/__init__.py (revision 303)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/dvi.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/dvi.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/dvi.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/analyzer.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/analyzer.py (revision 303)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/pjl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pjl.py (revision 252)
+++ pkpgcounter/trunk/pkpgpdls/pjl.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/pkpgpdls/version.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/version.py (revision 298)
+++ pkpgcounter/trunk/pkpgpdls/version.py (revision 303)
@@ -2,5 +2,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -20,5 +20,5 @@
 #
 
-__version__ = "1.74alpha1"
+__version__ = "1.74"
 
 __doc__ = """pkpgcounter : a generic Page Description Languages parser."""
@@ -26,5 +26,5 @@
 __author__ = "Jerome Alet"
 __authoremail__ = "alet@librelogiciel.com"
-__years__ = "2003, 2004, 2005"
+__years__ = "2003, 2004, 2005, 2006"
 
 __gplblurb__ = """This program is free software; you can redistribute it and/or modify
Index: pkpgcounter/trunk/setup.py
===================================================================
--- pkpgcounter/trunk/setup.py (revision 289)
+++ pkpgcounter/trunk/setup.py (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- pkpgcounter/trunk/bin/pkpgcounter (revision 235)
+++ pkpgcounter/trunk/bin/pkpgcounter (revision 303)
@@ -4,5 +4,5 @@
 # pkpgcounter : a generic Page Description Language parser
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/man/pkpgcounter.1
===================================================================
--- pkpgcounter/trunk/man/pkpgcounter.1 (revision 296)
+++ pkpgcounter/trunk/man/pkpgcounter.1 (revision 303)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKPGCOUNTER "1" "December 2005" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.35.
+.TH PKPGCOUNTER "1" "January 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkpgcounter \- manual page for pkpgcounter 1.73
+pkpgcounter \- manual page for pkpgcounter 1.74
 .SH DESCRIPTION
-pkpgcounter v1.73 (c) 2003, 2004, 2005 Jerome Alet
+pkpgcounter v1.74 (c) 2003, 2004, 2005, 2006 Jerome Alet
 .PP
 pkpgcounter is a generic Page Description Language parser.
Index: pkpgcounter/trunk/man/genman.sh
===================================================================
--- pkpgcounter/trunk/man/genman.sh (revision 223)
+++ pkpgcounter/trunk/man/genman.sh (revision 303)
@@ -3,5 +3,5 @@
 # pkpgcounter : a generic Page Description Language parser.
 #
-# (c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+# (c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 # You're welcome to redistribute this software under the
 # terms of the GNU General Public Licence version 2.0
Index: pkpgcounter/trunk/NEWS
===================================================================
--- pkpgcounter/trunk/NEWS (revision 295)
+++ pkpgcounter/trunk/NEWS (revision 303)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -22,4 +22,10 @@
 pkpgcounter News :
 
+  * 1.74 :
+  
+    - Fixed a problem in the retrieval of named media sizes in PCLXL.
+    
+    - Changed copyright years.
+    
   * 1.73 :
   
Index: pkpgcounter/trunk/CREDITS
===================================================================
--- pkpgcounter/trunk/CREDITS (revision 211)
+++ pkpgcounter/trunk/CREDITS (revision 303)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
Index: pkpgcounter/trunk/README
===================================================================
--- pkpgcounter/trunk/README (revision 286)
+++ pkpgcounter/trunk/README (revision 303)
@@ -3,5 +3,5 @@
 pkpgcounter : a generic Page Description Language parser
 
-(c) 2003, 2004, 2005 Jerome Alet <alet@librelogiciel.com>
+(c) 2003, 2004, 2005, 2006 Jerome Alet <alet@librelogiciel.com>
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by