Index: pkpgcounter/trunk/pkpgpdls/postscript.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/postscript.py (revision 308)
+++ pkpgcounter/trunk/pkpgpdls/postscript.py (revision 314)
@@ -85,10 +85,10 @@
         previousline = ""
         notrust = 0
-        kpdl = 0 # Kyocera Mita
+        prescribe = 0 # Kyocera's Prescribe commands
         for line in self.infile.xreadlines() : 
-            if (not kpdl) and line.startswith(r"%%BeginResource: procset pdf") :
+            if (not prescribe) and line.startswith(r"%%BeginResource: procset pdf") :
                 notrust = 1 # Let this stuff be managed by GhostScript, but we still extract number of copies
-            elif line.startswith("/KPDLBASE") :
-                kpdl = 1
+            elif line.startswith("!R!") :
+                prescribe = 1
             elif line.startswith(r"%%Page: ") or line.startswith(r"(%%[Page: ") :
                 proceed = 1
Index: pkpgcounter/trunk/pkpgpdls/pclxl.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 313)
+++ pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 314)
@@ -329,12 +329,13 @@
         """Handles the ESC code."""
         pos = endpos = self.pos
-        if self.minfile[pos : pos+8] == r"%-12345X" :
+        minfile = self.minfile
+        if minfile[pos : pos+8] == r"%-12345X" :
             endpos = pos + 9
             endmark = chr(0x0c) + chr(0x00) + chr(0x1b)
             asciilimit = chr(0x80)
             quotes = 0
-            while (self.minfile[endpos] not in endmark) and \
-                   ((self.minfile[endpos] < asciilimit) or (quotes % 2)) :
-                if self.minfile[endpos] == '"' :
+            while (minfile[endpos] not in endmark) and \
+                   ((minfile[endpos] < asciilimit) or (quotes % 2)) :
+                if minfile[endpos] == '"' :
                     quotes += 1
                 endpos += 1
@@ -343,16 +344,20 @@
             # NB : First time will be at page 0 (i.e. **before** page 1) !
             stuff = self.escapedStuff.setdefault(self.pagecount, [])
-            stuff.append(self.minfile[pos : endpos])
-            self.logdebug("Escaped datas : [%s]" % repr(self.minfile[pos : endpos]))
+            stuff.append(minfile[pos : endpos])
+            self.logdebug("Escaped datas : [%s]" % repr(minfile[pos : endpos]))
         return endpos - pos
         
     def skipKyoceraPrescribe(self) :    
         """Skips Kyocera Prescribe commands."""
+        pos = self.pos - 1
         minfile = self.minfile
-        pos = self.pos - 1
         if minfile[pos:pos+3] == "!R!" :
             while (pos - self.pos) < 1024 :   # This is a realistic upper bound, to avoid infinite loops
                 if (minfile[pos] == ";") and (minfile[pos-4:pos] == "EXIT") :
-                    return (pos + 1 - self.pos)
+                    pos += 1
+                    prescribe = self.prescribeStuff.setdefault(self.pagecount, [])
+                    prescribe.append(minfile[self.pos-1:pos])
+                    self.logdebug("Prescribe commands : [%s]" % repr(minfile[self.pos-1:pos]))
+                    return (pos - self.pos)
                 pos += 1    
         else :
@@ -567,5 +572,6 @@
         tags = self.tags
         self.pagecount = 0
-        self.escapedStuff = {}
+        self.escapedStuff = {}   # For escaped datas, mostly PJL commands
+        self.prescribeStuff = {} # For Kyocera Prescribe commands
         self.pos = pos = oldpos = 0
         try :
Index: pkpgcounter/trunk/pkpgpdls/version.py
===================================================================
--- pkpgcounter/trunk/pkpgpdls/version.py (revision 307)
+++ pkpgcounter/trunk/pkpgpdls/version.py (revision 314)
@@ -20,5 +20,5 @@
 #
 
-__version__ = "1.76beta"
+__version__ = "1.76"
 
 __doc__ = """pkpgcounter : a generic Page Description Languages parser."""
Index: pkpgcounter/trunk/man/pkpgcounter.1
===================================================================
--- pkpgcounter/trunk/man/pkpgcounter.1 (revision 303)
+++ pkpgcounter/trunk/man/pkpgcounter.1 (revision 314)
@@ -1,8 +1,8 @@
-.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.35.
-.TH PKPGCOUNTER "1" "January 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
+.TH PKPGCOUNTER "1" "February 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NAME
-pkpgcounter \- manual page for pkpgcounter 1.74
+pkpgcounter \- manual page for pkpgcounter 1.76
 .SH DESCRIPTION
-pkpgcounter v1.74 (c) 2003, 2004, 2005, 2006 Jerome Alet
+pkpgcounter v1.76 (c) 2003, 2004, 2005, 2006 Jerome Alet
 .PP
 pkpgcounter is a generic Page Description Language parser.
Index: pkpgcounter/trunk/NEWS
===================================================================
--- pkpgcounter/trunk/NEWS (revision 305)
+++ pkpgcounter/trunk/NEWS (revision 314)
@@ -22,4 +22,10 @@
 pkpgcounter News :
 
+  * 1.76 :
+  
+    - Improved the PCLXL parser wrt undocumented tags.
+    
+    - Preliminary support for Kyocera Prescribe commands.
+    
   * 1.75 :
   