Index: /pkpgcounter/trunk/pkpgpdls/pcl345.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 357)
+++ /pkpgcounter/trunk/pkpgpdls/pcl345.py (revision 375)
@@ -34,4 +34,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for PCL3, PCL4, PCL5 documents."""
+    totiffcommand = 'pcl6 -sDEVICE=pdfwrite -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -sOutputFile=- - | gs -sDEVICE=tiff24nc -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -r%(dpi)i -sOutputFile="%(fname)s" -'
     mediasizes = {  # ESC&l####A
                     0 : "Default",
Index: /pkpgcounter/trunk/pkpgpdls/pclxl.py
===================================================================
--- /pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 357)
+++ /pkpgcounter/trunk/pkpgpdls/pclxl.py (revision 375)
@@ -34,4 +34,5 @@
 class Parser(pdlparser.PDLParser) :
     """A parser for PCLXL (aka PCL6) documents."""
+    totiffcommand = 'pcl6 -sDEVICE=pdfwrite -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -sOutputFile=- - | gs -sDEVICE=tiff24nc -dPARANOIDSAFER -dNOPAUSE -dBATCH -dQUIET -r%(dpi)i -sOutputFile="%(fname)s" -'
     mediasizes = { 
                     0 : "Letter",
Index: /pkpgcounter/trunk/bin/pkpgcounter
===================================================================
--- /pkpgcounter/trunk/bin/pkpgcounter (revision 374)
+++ /pkpgcounter/trunk/bin/pkpgcounter (revision 375)
@@ -38,6 +38,5 @@
 colorspaces for several file formats.
 
-pkpgcounter currently recognizes the following document formats for
-page counting :
+pkpgcounter currently recognizes the following document formats :
 
     * PostScript (both DSC compliant and binary)
@@ -51,11 +50,6 @@
     * Zenographics ZjStream
 
-pkpgcounter currently recognizes the following document formats
-for the computation of ink coverage :
-
-    * PostScript (both DSC compliant and binary)
-    * PDF   
-    * DVI
-    * TIFF (some TIFF files don't work)
+The three latter ones, as well as some TIFF documents, are currently 
+only supported in page counting mode. 
 
 command line usage :
Index: /pkpgcounter/trunk/README
===================================================================
--- /pkpgcounter/trunk/README (revision 374)
+++ /pkpgcounter/trunk/README (revision 375)
@@ -20,7 +20,9 @@
 =============================================================================
 
-pkpgcounter is a generic Page Description Language parser.
+pkpgcounter is a generic Page Description Language parser which can either
+compute the number of pages in a document, or compute the percent of
+ink coverage needed to print each page, in different colorspaces.
 
-It can currently compute the number of pages in several types of files :
+pkpgcounter currently recognizes the following document formats :
 
         - PostScript (both DSC compliant and binary)
@@ -32,9 +34,9 @@
         - PCLXL (aka PCL6)
         
-        - ESC/P2
-        
         - DVI
         
         - TIFF
+        
+        - ESC/P2
         
         - OpenDocument (ISO/IEC DIS 26300)
@@ -42,16 +44,6 @@
         - Zenographics ZjStream
         
-In addition to counting pages, pkpgcounter can also compute the        
-ink coverage for the following document types :
-
-        - PostScript (both DSC compliant and binary)
-        
-        - PDF
-        
-        - DVI 
-        
-        - TIFF (some TIFF files don't work)
-        
-Other formats will be supported in the future for ink coverage.        
+The three latter ones, as well as some TIFF documents, are currently 
+only supported in page counting mode. 
 
 By default, when launched pkpgcounter prints on its standard output 
@@ -64,5 +56,5 @@
 representing the files to parse.
 
-See pkpgcounter --help for details.
+See pkpgcounter --help for details and examples.
 
 =============================================================================
@@ -106,10 +98,13 @@
 software which must be installed. These third party software are :
 
-        - GhostScript.
+        - GhostScript (this one is needed for all file formats).
         
-        - The Python Imaging Library (PIL).
+        - The Python Imaging Library, aka PIL (this one is needed for all
+          file formats).
         
+        - GhostPCL (this one is needed for the PCL3/4/5 and PCLXL formats)
+          
         - The LaTeX typesetting software, in particular the dvips command
-          (this one is only needed for the DVI file format).
+          (this one is needed for the DVI file format).
         
 =============================================================================